package com.lzmispt.data.resource.service.metadata.impl;

package .tmp;

import com.lzmispt.core.entity.vo.authorize.DataAuthorizeTreeVO;
import com.lzmispt.data.center.entity.dto.resource.metadata.DeleteDirectoryDTO;
import com.lzmispt.data.center.entity.dto.resource.metadata.GetDirectoryTreeDataDTO;
import com.lzmispt.data.center.entity.enums.StatusCodeEnum;
import com.lzmispt.data.center.entity.vo.resource.metadata.DirectoryTreeVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.GetFileTableAndChildVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.GetMetadataEntityAndDirVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.GetMetadataEntityInfoVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataDirectoryUsageVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataEntityVO;
import com.lzmispt.data.resource.entity.dto.metadata.DragDirectoryDTO;
import com.lzmispt.data.resource.entity.dto.metadata.ImportMetadataEntityDTO;
import com.lzmispt.data.resource.entity.dto.metadata.MetadataDirectoryDTO;
import com.lzmispt.data.resource.entity.dto.metadata.SaveMetadataEntityDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataDirectoryDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataEntityDTO;
import com.lzmispt.data.resource.entity.vo.metadata.SelectMetadataEntityVO;
import com.lzmispt.data.resource.manager.metadata.MetadataManager;
import com.lzmispt.data.resource.service.metadata.IDataResource;
import com.lzmispt.data.resource.service.metadata.IResAndDataResource;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.framework.entity.entity.ResultEntity;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

@Service
public class IResAndDataResourceImpl implements IResAndDataResource {
  private static final String QUERY_KEY = "query";
  
  public ResultEntity<List<GetFileTableAndChildVO>> getChildByDirectoryIdForResources(Long directoryId, String platCode, String tokenId) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getChildByDirectoryId(directoryId, platCode, tokenId, DCConst.DataResourceCategory.RES);
  }
  
  public ResultEntity<List<GetFileTableAndChildVO>> getChildByDirectoryIdForMetadata(Long directoryId, String platCode, String tokenId) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getChildByDirectoryId(directoryId, platCode, tokenId, DCConst.DataResourceCategory.DATA);
  }
  
  public ResultEntity<Boolean> deleteDirectoryByDirectoryIdForResources(DeleteDirectoryDTO deleteParam, String tokenId, String platCode) {
    deleteParam.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    deleteParam.setPlatCode(platCode);
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).deleteDirectoryByDirectoryId(deleteParam, tokenId);
  }
  
  public ResultEntity<Boolean> deleteDirectoryByDirectoryIdForMetadata(DeleteDirectoryDTO deleteParam, String tokenId, String platCode) {
    deleteParam.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    deleteParam.setPlatCode(platCode);
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).deleteDirectoryByDirectoryId(deleteParam, tokenId);
  }
  
  public ResultEntity<DirectoryTreeVO> saveMetadataDirectoryForResources(MetadataDirectoryDTO metadataDirectoryDTO, String tokenId, String platCode) {
    metadataDirectoryDTO.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).saveMetadataDirectory(metadataDirectoryDTO, tokenId, platCode);
  }
  
  public ResultEntity<DirectoryTreeVO> saveMetadataDirectoryForMetadata(MetadataDirectoryDTO metadataDirectoryDTO, String tokenId, String platCode) {
    metadataDirectoryDTO.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).saveMetadataDirectory(metadataDirectoryDTO, tokenId, platCode);
  }
  
  public ResultEntity<Boolean> saveMetadataEntityForResources(SaveMetadataEntityDTO saveMetadataEntityDTO, String platCode) {
    saveMetadataEntityDTO.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    saveMetadataEntityDTO.setPlatCode(platCode);
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).saveMetadataEntity(saveMetadataEntityDTO);
  }
  
  public ResultEntity<Boolean> saveMetadataEntityForMetadata(SaveMetadataEntityDTO saveMetadataEntityDTO, String platCode) {
    saveMetadataEntityDTO.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    saveMetadataEntityDTO.setPlatCode(platCode);
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).saveMetadataEntity(saveMetadataEntityDTO);
  }
  
  public ResultEntity<List<DirectoryTreeVO>> getDirectoryTreeDataForResources(String platCode, GetDirectoryTreeDataDTO getDirectoryTreeDataDTO) {
    getDirectoryTreeDataDTO.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    getDirectoryTreeDataDTO.setIsReturnLayerType(DCConst.TRUE);
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getDirectoryTreeData(platCode, getDirectoryTreeDataDTO);
  }
  
  public ResultEntity<List<DataAuthorizeTreeVO>> getManageResDirectoryTree(Map<String, Object> param) {
    List<DataAuthorizeTreeVO> dataAuthorizeTreeVOList = new ArrayList<>();
    Map<String, String> queryParam = new HashMap<>();
    List<Map<String, String>> query = null;
    if (param.containsKey("query") && param.get("query") != null)
      query = (List<Map<String, String>>)param.get("query"); 
    if (!CollectionUtils.isEmpty(query) && query.size() > 0)
      queryParam = query.get(0); 
    List<ResAndDataDirectoryDTO> resAndDataDirectoryDTOList = MetadataManager.getManageResDirectoryTree(queryParam, "Manage");
    if (!CollectionUtils.isEmpty(resAndDataDirectoryDTOList)) {
      for (ResAndDataDirectoryDTO item : resAndDataDirectoryDTOList) {
        DataAuthorizeTreeVO dataAuthorizeTreeVO = new DataAuthorizeTreeVO();
        dataAuthorizeTreeVO.setId(item.getDirectoryId().toString());
        dataAuthorizeTreeVO.setParent_id((item.getParentDirectoryId() == null) ? null : item.getParentDirectoryId().toString());
        dataAuthorizeTreeVO.setName(item.getDirectoryName());
        dataAuthorizeTreeVO.setType(item.getDirectoryType());
        dataAuthorizeTreeVO.setIs_match_query(Integer.valueOf(1));
        dataAuthorizeTreeVO.setChildren(new ArrayList());
        dataAuthorizeTreeVOList.add(dataAuthorizeTreeVO);
      } 
      dataAuthorizeTreeVOList = listToTree(dataAuthorizeTreeVOList);
    } 
    return ResultEntity.successMessage(dataAuthorizeTreeVOList);
  }
  
  private List<DataAuthorizeTreeVO> listToTree(List<DataAuthorizeTreeVO> sourceList) {
    List<DataAuthorizeTreeVO> rootNodes = new ArrayList<>();
    Map<String, List<DataAuthorizeTreeVO>> childNodesMap = new HashMap<>();
    for (DataAuthorizeTreeVO node : sourceList) {
      if (childNodesMap.get(node.getId()) == null)
        childNodesMap.put(node.getId(), new ArrayList<>()); 
      node.setChildren(childNodesMap.get(node.getId()));
      if (node.getParent_id() == null)
        rootNodes.add(node); 
      if (node.getParent_id() != null) {
        if (childNodesMap.get(node.getParent_id()) == null)
          childNodesMap.put(node.getParent_id(), new ArrayList<>()); 
        ((List<DataAuthorizeTreeVO>)childNodesMap.get(node.getParent_id())).add(node);
      } 
    } 
    return rootNodes;
  }
  
  public ResultEntity<List<DirectoryTreeVO>> getDirectoryTreeDataForMetadata(String platCode, GetDirectoryTreeDataDTO getDirectoryTreeDataDTO) {
    getDirectoryTreeDataDTO.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    getDirectoryTreeDataDTO.setIsReturnLayerType(DCConst.TRUE);
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getDirectoryTreeData(platCode, getDirectoryTreeDataDTO);
  }
  
  public ResultEntity<SelectMetadataEntityVO> getMetadataEntityByDirectoryIdForResources(Long directoryId, String tokenId, String platCode) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getMetadataEntityByDirectoryId(directoryId, tokenId, DCConst.DataResourceCategory.RES, platCode, null);
  }
  
  public ResultEntity<SelectMetadataEntityVO> getMetadataEntityByDirectoryIdForMetadata(Long directoryId, String tokenId, String platCode, Integer versionType) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getMetadataEntityByDirectoryId(directoryId, tokenId, DCConst.DataResourceCategory.DATA, platCode, versionType);
  }
  
  public ResultEntity<GetMetadataEntityInfoVO> getEntityInfoByDirectoryIdForResources(Long directoryId, String tokenId, String platCode) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getEntityInfoByDirectoryId(directoryId, tokenId, DCConst.DataResourceCategory.RES, platCode);
  }
  
  public ResultEntity<GetMetadataEntityInfoVO> getEntityInfoByDirectoryIdForMetadata(Long directoryId, String tokenId, String platCode) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getEntityInfoByDirectoryId(directoryId, tokenId, DCConst.DataResourceCategory.DATA, platCode);
  }
  
  public ResultEntity<Boolean> checkDeleteDirectoryByDirectoryIdForResources(String platCode, String tokenId, Long directoryId) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).checkDeleteDirectoryByDirectoryId(platCode, tokenId, directoryId, DCConst.DataResourceCategory.RES);
  }
  
  public ResultEntity<Boolean> checkDeleteDirectoryByDirectoryIdForMetadata(String platCode, String tokenId, Long directoryId) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).checkDeleteDirectoryByDirectoryId(platCode, tokenId, directoryId, DCConst.DataResourceCategory.DATA);
  }
  
  public ResultEntity<Boolean> dragDirectoryForResources(DragDirectoryDTO dragDirectoryDTO) {
    dragDirectoryDTO.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    return ((IDataResource)ServiceUtil.getDataResourceManager(dragDirectoryDTO.getPlatCode(), IDataResource.class)).dragDirectory(dragDirectoryDTO);
  }
  
  public ResultEntity<Boolean> dragDirectoryForMetadata(DragDirectoryDTO dragDirectoryDTO) {
    dragDirectoryDTO.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    return ((IDataResource)ServiceUtil.getDataResourceManager(dragDirectoryDTO.getPlatCode(), IDataResource.class)).dragDirectory(dragDirectoryDTO);
  }
  
  public ResultEntity<List<DirectoryTreeVO>> importMetadataEntityForResources(ImportMetadataEntityDTO importMetadataEntityDTO, String platCode, String tokenId) {
    importMetadataEntityDTO.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).importMetadataEntity(importMetadataEntityDTO, platCode, tokenId);
  }
  
  public ResultEntity<List<DirectoryTreeVO>> importMetadataEntityForMetadata(ImportMetadataEntityDTO importMetadataEntityDTO, String platCode, String tokenId) {
    importMetadataEntityDTO.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).importMetadataEntity(importMetadataEntityDTO, platCode, tokenId);
  }
  
  public ResultEntity<Integer> getMaxDirectoryOrderByDirectoryIdForResources(GetDirectoryTreeDataDTO getDirectoryTreeDataDTO) {
    getDirectoryTreeDataDTO.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    return ((IDataResource)ServiceUtil.getDataResourceManager(getDirectoryTreeDataDTO.getPlatCode(), IDataResource.class)).getMaxDirectoryOrderByDirectoryId(getDirectoryTreeDataDTO);
  }
  
  public ResultEntity<Integer> getMaxDirectoryOrderByDirectoryIdForMetadata(GetDirectoryTreeDataDTO getDirectoryTreeDataDTO) {
    getDirectoryTreeDataDTO.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    return ((IDataResource)ServiceUtil.getDataResourceManager(getDirectoryTreeDataDTO.getPlatCode(), IDataResource.class)).getMaxDirectoryOrderByDirectoryId(getDirectoryTreeDataDTO);
  }
  
  public ResultEntity<MetadataDirectoryUsageVO> getDirectoryUsedInfoForMetadata(DeleteDirectoryDTO deleteParam, String platCode, String tokenId) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getDirectoryUsedInfo(deleteParam, platCode, tokenId, DCConst.DataResourceCategory.DATA);
  }
  
  public ResultEntity<MetadataDirectoryUsageVO> getDirectoryUsedInfoForRes(DeleteDirectoryDTO deleteParam, String platCode, String tokenId) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getDirectoryUsedInfo(deleteParam, platCode, tokenId, DCConst.DataResourceCategory.RES);
  }
  
  public ResultEntity<MetadataDirectoryUsageVO> getDirectoryUsedInfoForUpdateForMetadata(DeleteDirectoryDTO deleteParam, String platCode, String tokenId) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getDirectoryUsedInfoForUpdate(deleteParam, platCode, tokenId, DCConst.DataResourceCategory.DATA);
  }
  
  public ResultEntity<MetadataDirectoryUsageVO> getDirectoryUsedInfoForUpdateForRes(DeleteDirectoryDTO deleteParam, String platCode, String tokenId) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getDirectoryUsedInfoForUpdate(deleteParam, platCode, tokenId, DCConst.DataResourceCategory.RES);
  }
  
  public ResultEntity<MetadataEntityVO> getMetadataEntityByDirectoyIdForMetadata(Long directoryId, String platCode, String tokenId) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getMetadataEntityByDirectoyId(directoryId, tokenId, DCConst.DataResourceCategory.DATA, platCode);
  }
  
  public ResultEntity<MetadataEntityVO> getMetadataEntityByDirectoyIdForRes(Long directoryId, String platCode, String tokenId) {
    return ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).getMetadataEntityByDirectoyId(directoryId, tokenId, DCConst.DataResourceCategory.RES, platCode);
  }
  
  public ResultEntity<GetMetadataEntityAndDirVO> getMetadataEntityByEntityCodeForMetadata(String entityCode, String tokenId, String platCode) {
    return getEntityByEntityCode(entityCode, tokenId, platCode, DCConst.DataResourceCategory.DATA);
  }
  
  public ResultEntity<GetMetadataEntityAndDirVO> getMetadataEntityByEntityCodeForRes(String entityCode, String tokenId, String platCode) {
    return getEntityByEntityCode(entityCode, tokenId, platCode, DCConst.DataResourceCategory.RES);
  }
  
  private ResultEntity<GetMetadataEntityAndDirVO> getEntityByEntityCode(String entityCode, String tokenId, String platCode, Integer dataResourceCategory) {
    ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectIsMasterMetadataEntityByEntityCode(entityCode, dataResourceCategory, platCode, tokenId);
    if (resAndDataEntityDTO == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_ENTITY_NOT_CREATED.getCode()), StatusCodeEnum.DATA_RESOURCE_ENTITY_NOT_CREATED
          .getMessage()); 
    GetMetadataEntityAndDirVO metadataEntityAndDirVO = new GetMetadataEntityAndDirVO();
    metadataEntityAndDirVO.setEntityId(resAndDataEntityDTO.getEntityId());
    metadataEntityAndDirVO.setEntityName(resAndDataEntityDTO.getEntityName());
    ResAndDataDirectoryDTO resAndDataDirectoryDTO = MetadataManager.selectDirectoryByDirectoryId(resAndDataEntityDTO.getDirectoryId(), platCode, dataResourceCategory);
    metadataEntityAndDirVO.setDirectoryId(resAndDataDirectoryDTO.getDirectoryId());
    metadataEntityAndDirVO.setDirectoryName(resAndDataDirectoryDTO.getDirectoryName());
    metadataEntityAndDirVO.setParentDirectoryId(resAndDataDirectoryDTO.getParentDirectoryId());
    metadataEntityAndDirVO.setDirectoryType(resAndDataDirectoryDTO.getDirectoryType());
    return ResultEntity.successMessage(metadataEntityAndDirVO);
  }
}
